#DEFINE C_PROC	"foldersdef.prg"

LOCAL ;
	lcCurPath as String;
	,lcOldPath as String
lcCurPath = Sys(16)
IF EMPTY(lcCurPath)
	lcCurPath = LOWER(FULLPATH(CURDIR()))
ELSE
	LOCAL lnLBS as Integer
	lnLBS = RATC('\', lcCurPath)
	IF lnLBS > 0
		lcCurPath = LOWER(LEFTC(lcCurPath, lnLBS))
	ENDIF
ENDIF
lcOldPath = LOWER(FULLPATH(CURDIR()))
SET DEFAULT TO (lcCurPath)

IF !FILE(C_PROC)
	RETURN .F.
ENDIF

IF !(UPPER(JUSTSTEM(C_PROC)) $ SET("Procedure"))
	SET PROCEDURE TO (C_PROC) ADDITIVE
ENDIF	
	
LOCAL loFolders As sesFolders
loFolders = NEWOBJECT("sesFolders")
IF VARTYPE(loFolders) # 'O'
	RETURN .F.
ENDIF
LOCAL lcRootFolder as String
lcRootFolder = LOWER(HOME()) 
IF loFolders.FillCursorFolders(lcRootFolder)
	LOCAL lnOldDsID as Number
	lnOldDsID = SET("Datasession")  
	SET DATASESSION TO (loFolders.DataSessionID)
	IF USED(loFolders.cCursorFolders)
		SELECT (loFolders.cCursorFolders)
		GO TOP
		WAIT WINDOW "List of folders in "+CHR(13)+CHR(10)+lcRootFolder NOWAIT
		BROWSE NORM
	ENDIF
	IF USED(loFolders.cCursorRefs)
		SELECT (loFolders.cCursorRefs)
		GO TOP
		WAIT WINDOW "References between folders" NOWAIT
		BROWSE NORM
	ENDIF
	LOCAL lcFolder as String
	GO TOP IN (loFolders.cCursorFolders)
	lcFolder = EVALUATE(loFolders.cCursorFolders+'.Name')
	loFolders.closeCursorFolders() 
	IF loFolders.FillCursorFiles(lcFolder)
		IF USED(loFolders.cCursorFiles)
			SELECT (loFolders.cCursorFiles)
			GO TOP
			WAIT WINDOW "List of files in "+CHR(13)+CHR(10)+lcFolder NOWAIT
			BROWSE NORM
		ENDIF
		loFolders.CloseCursorFiles() 
	ENDIF
	SET DATASESSION TO (lnOldDsID)
ENDIF

SET DEFAULT TO (lcOldPath)